module Reflex.Filesystem.DirTree
 ( DirTree
 , DynDirTree
 ) where

import           Data.ListTrie.Patricia.Map.Ord (TrieMap)
import           Data.Text (Text)
import           Reflex

-- | Our DirTree model only allows Text filenames.
--   This allows easier processing but doesn't match POSIX's actual richness.
type DirTree a = TrieMap Text a

-- | Our basic ALON type for, representing at various turns directories and site URL
type DynDirTree t a = Dynamic t (DirTree (Dynamic t a))
